# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_driver_msgs/ChargerState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ChargerState(genpy.Message):
  _md5sum = "ec28a2b551b0a76f44243d270192fe11"
  _type = "fetch_driver_msgs/ChargerState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint8 state
uint8 error
# Charging mode is defined as:
#  0 - float charge (last 10%)
#  1 - charging
#  2 - not charging
uint8 charging_mode
uint8 limit_cause
uint8 balancing_mode

float32 battery_voltage
float32 battery_half_voltage
float32 charger_voltage
float32 supply_voltage

float32 phase1_current
float32 phase2_current

float32 charger_temp
float32 battery_temp
float32 supply_connector_temp

float32 fan_speed

float32 battery_capacity
float32 battery_energy
"""
  __slots__ = ['state','error','charging_mode','limit_cause','balancing_mode','battery_voltage','battery_half_voltage','charger_voltage','supply_voltage','phase1_current','phase2_current','charger_temp','battery_temp','supply_connector_temp','fan_speed','battery_capacity','battery_energy']
  _slot_types = ['uint8','uint8','uint8','uint8','uint8','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       state,error,charging_mode,limit_cause,balancing_mode,battery_voltage,battery_half_voltage,charger_voltage,supply_voltage,phase1_current,phase2_current,charger_temp,battery_temp,supply_connector_temp,fan_speed,battery_capacity,battery_energy

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ChargerState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.state is None:
        self.state = 0
      if self.error is None:
        self.error = 0
      if self.charging_mode is None:
        self.charging_mode = 0
      if self.limit_cause is None:
        self.limit_cause = 0
      if self.balancing_mode is None:
        self.balancing_mode = 0
      if self.battery_voltage is None:
        self.battery_voltage = 0.
      if self.battery_half_voltage is None:
        self.battery_half_voltage = 0.
      if self.charger_voltage is None:
        self.charger_voltage = 0.
      if self.supply_voltage is None:
        self.supply_voltage = 0.
      if self.phase1_current is None:
        self.phase1_current = 0.
      if self.phase2_current is None:
        self.phase2_current = 0.
      if self.charger_temp is None:
        self.charger_temp = 0.
      if self.battery_temp is None:
        self.battery_temp = 0.
      if self.supply_connector_temp is None:
        self.supply_connector_temp = 0.
      if self.fan_speed is None:
        self.fan_speed = 0.
      if self.battery_capacity is None:
        self.battery_capacity = 0.
      if self.battery_energy is None:
        self.battery_energy = 0.
    else:
      self.state = 0
      self.error = 0
      self.charging_mode = 0
      self.limit_cause = 0
      self.balancing_mode = 0
      self.battery_voltage = 0.
      self.battery_half_voltage = 0.
      self.charger_voltage = 0.
      self.supply_voltage = 0.
      self.phase1_current = 0.
      self.phase2_current = 0.
      self.charger_temp = 0.
      self.battery_temp = 0.
      self.supply_connector_temp = 0.
      self.fan_speed = 0.
      self.battery_capacity = 0.
      self.battery_energy = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_5B12f().pack(_x.state, _x.error, _x.charging_mode, _x.limit_cause, _x.balancing_mode, _x.battery_voltage, _x.battery_half_voltage, _x.charger_voltage, _x.supply_voltage, _x.phase1_current, _x.phase2_current, _x.charger_temp, _x.battery_temp, _x.supply_connector_temp, _x.fan_speed, _x.battery_capacity, _x.battery_energy))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 53
      (_x.state, _x.error, _x.charging_mode, _x.limit_cause, _x.balancing_mode, _x.battery_voltage, _x.battery_half_voltage, _x.charger_voltage, _x.supply_voltage, _x.phase1_current, _x.phase2_current, _x.charger_temp, _x.battery_temp, _x.supply_connector_temp, _x.fan_speed, _x.battery_capacity, _x.battery_energy,) = _get_struct_5B12f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_5B12f().pack(_x.state, _x.error, _x.charging_mode, _x.limit_cause, _x.balancing_mode, _x.battery_voltage, _x.battery_half_voltage, _x.charger_voltage, _x.supply_voltage, _x.phase1_current, _x.phase2_current, _x.charger_temp, _x.battery_temp, _x.supply_connector_temp, _x.fan_speed, _x.battery_capacity, _x.battery_energy))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 53
      (_x.state, _x.error, _x.charging_mode, _x.limit_cause, _x.balancing_mode, _x.battery_voltage, _x.battery_half_voltage, _x.charger_voltage, _x.supply_voltage, _x.phase1_current, _x.phase2_current, _x.charger_temp, _x.battery_temp, _x.supply_connector_temp, _x.fan_speed, _x.battery_capacity, _x.battery_energy,) = _get_struct_5B12f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5B12f = None
def _get_struct_5B12f():
    global _struct_5B12f
    if _struct_5B12f is None:
        _struct_5B12f = struct.Struct("<5B12f")
    return _struct_5B12f
