# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_driver_msgs/Gyro.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class Gyro(genpy.Message):
  _md5sum = "7e55d268dcc35aae7026f0428ed61292"
  _type = "fetch_driver_msgs/Gyro"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header

uint32 flags

# Scaled and offset gyro axis values
geometry_msgs/Vector3 data

# Raw data from gyro (unscaled, and unofffset) 
geometry_msgs/Vector3 raw

# Scale values used for each axis
geometry_msgs/Vector3 scale

# Offset value used for each axis
geometry_msgs/Vector3 offset


# Glitch was detected
uint32 GLITCH = 1

# Problem initializing gyro
uint32 INIT_ERROR = 2

# Error reading data
uint32 READ_ERROR = 4

# Interrupt for new data is not being triggered fast enough
uint32 INTERRUPT_TOO_SLOW = 8

# Interrupt for new data is being triggrered to quickly
uint32 INTERRUPT_TOO_FAST = 16

# No sensor is availble
uint32 SENSOR_NOT_PRESENT = 32

# Robot is definitely moving, gyro output should be non-zero 
uint32 DEFINITELY_MOVING = 536870912   # 1<<29

# Robot is definitely stopped, gyro offset can be adjusted
uint32 DEFINITELY_STOPPED = 1073741824   # 1<<30

# Robot gyro has any type of error, can be used for ignoring
# invalid gyro data even without understanding any specific
# error types
uint32 ANY_ERROR = 2147483648   # 1<<31


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  # Pseudo-constants
  GLITCH = 1
  INIT_ERROR = 2
  READ_ERROR = 4
  INTERRUPT_TOO_SLOW = 8
  INTERRUPT_TOO_FAST = 16
  SENSOR_NOT_PRESENT = 32
  DEFINITELY_MOVING = 536870912
  DEFINITELY_STOPPED = 1073741824
  ANY_ERROR = 2147483648

  __slots__ = ['header','flags','data','raw','scale','offset']
  _slot_types = ['std_msgs/Header','uint32','geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Vector3']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,flags,data,raw,scale,offset

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Gyro, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.flags is None:
        self.flags = 0
      if self.data is None:
        self.data = geometry_msgs.msg.Vector3()
      if self.raw is None:
        self.raw = geometry_msgs.msg.Vector3()
      if self.scale is None:
        self.scale = geometry_msgs.msg.Vector3()
      if self.offset is None:
        self.offset = geometry_msgs.msg.Vector3()
    else:
      self.header = std_msgs.msg.Header()
      self.flags = 0
      self.data = geometry_msgs.msg.Vector3()
      self.raw = geometry_msgs.msg.Vector3()
      self.scale = geometry_msgs.msg.Vector3()
      self.offset = geometry_msgs.msg.Vector3()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_I12d().pack(_x.flags, _x.data.x, _x.data.y, _x.data.z, _x.raw.x, _x.raw.y, _x.raw.z, _x.scale.x, _x.scale.y, _x.scale.z, _x.offset.x, _x.offset.y, _x.offset.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.data is None:
        self.data = geometry_msgs.msg.Vector3()
      if self.raw is None:
        self.raw = geometry_msgs.msg.Vector3()
      if self.scale is None:
        self.scale = geometry_msgs.msg.Vector3()
      if self.offset is None:
        self.offset = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 100
      (_x.flags, _x.data.x, _x.data.y, _x.data.z, _x.raw.x, _x.raw.y, _x.raw.z, _x.scale.x, _x.scale.y, _x.scale.z, _x.offset.x, _x.offset.y, _x.offset.z,) = _get_struct_I12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_I12d().pack(_x.flags, _x.data.x, _x.data.y, _x.data.z, _x.raw.x, _x.raw.y, _x.raw.z, _x.scale.x, _x.scale.y, _x.scale.z, _x.offset.x, _x.offset.y, _x.offset.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.data is None:
        self.data = geometry_msgs.msg.Vector3()
      if self.raw is None:
        self.raw = geometry_msgs.msg.Vector3()
      if self.scale is None:
        self.scale = geometry_msgs.msg.Vector3()
      if self.offset is None:
        self.offset = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 100
      (_x.flags, _x.data.x, _x.data.y, _x.data.z, _x.raw.x, _x.raw.y, _x.raw.z, _x.scale.x, _x.scale.y, _x.scale.z, _x.offset.x, _x.offset.y, _x.offset.z,) = _get_struct_I12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_I12d = None
def _get_struct_I12d():
    global _struct_I12d
    if _struct_I12d is None:
        _struct_I12d = struct.Struct("<I12d")
    return _struct_I12d
